<?php //  -----------------------------------------------------------------  //
//  Projekt: eBiene mySQL-Backup 0.7                                         //
//  Download: http://lab.eBiene.de                                           //
//  Autor: Sergej Mueller                                                    //
//                                                                           //
//  Dateiname: index.php                                                     //
//  Bearbeitungsdatum: 16. Februar 2004                                      //
//  -----------------------------------------------------------------------  //

// Global-Klasse einbinden & initialisieren
require 'require/global.class.php';
$GLOBALS['global_class'] = new backup_global_class();

// Konfiguration einbinden
require 'config/config.php';

// Auf neue Version prfen
if (isset($_GET['get_version_control'])) {
  $GLOBALS['global_class']->get_version_control();
} else {
  // mySQL-Klasse einbinden & initialisieren
  require 'require/mysql.class.php';
  $GLOBALS['mysql_class'] = new mysql_database_class();
  
  if ($_POST) {
    // Backup-Klasse einbinden & initialisieren
	  require 'require/backup.class.php';
	  $GLOBALS['backup_class'] = new backup_mysql_class();
	  
	  // Backup der Tabellen starten
    $GLOBALS['backup_class']->backup_mysql_tables();
  } else {
    // Tabellen der Datenbank auslesen
	  $mysql_tables = $GLOBALS['global_class']->get_mysql_tables();
  }
}
?>

<html>
<head>
  <title>eBiene mySQL-Backup | Version <?php echo MYSQL_BACKUP_VERSION ?></title>
  <link rel=stylesheet href="css/style.css" type="text/css">
  
  <?php if (isset($mysql_tables) && $mysql_tables) { ?>
    <script language=javascript>
      var global_selected_status = true;
	  
	    // Elemente auswaehlen
      function checkElements() {
	      var fo = document.mysql_backup;
	      
	      selected_status = (global_selected_status) ? false : true;
	      global_selected_status = (selected_status) ? true : false;
	      
	      for (i = 0; i < fo.elements.length; i ++) {
	        fo.elements[i].checked = selected_status;
	      }
      }
	    
	    // Formular absenden
	    function submitForm() {
	      var fo = document.mysql_backup;
	      
        mysql_extras_array = new Array(4);
	      mysql_extras_array['save_as_sql'] = <?php echo ($GLOBALS['global_class']->get_file_exists(MYSQL_DATABASE. '.sql')) ? 'true' : 'false' ?>;
	      mysql_extras_array['save_as_gzip'] = <?php echo ($GLOBALS['global_class']->get_file_exists(MYSQL_DATABASE. '.sql.gz')) ? 'true' : 'false' ?>;
	      mysql_extras_array['save_as_sql_with_date'] = <?php echo ($GLOBALS['global_class']->get_file_exists(MYSQL_DATABASE. '_' .date('Ymd'). '.sql')) ? 'true' : 'false' ?>;
	      mysql_extras_array['save_as_gzip_with_date'] = <?php echo ($GLOBALS['global_class']->get_file_exists(MYSQL_DATABASE. '_' .date('Ymd'). '.sql.gz')) ? 'true' : 'false' ?>;
	      
	      if (mysql_extras_array[fo.mysql_extras.value]) {
	        if (confirm("Im Backup-Verzeichnis existiert bereits eine Datei mit gleichem Namen.\nSoll diese nun aktualisiert werden?")) {
	          return true;
		      } else {
		        return false;
		      }
	      } else {
	        return true;
	      }
	    }
    </script>
  <?php } ?>
</head>

<body scroll=auto>
<table width="100%" height="100%" cellspacing=0 cellpadding=0 border=0>
  <tr>
    <td align=center>
	    <table width=505 cellspacing=0 cellpadding=2 border=0>
	      <tr>
		      <td nowrap class=head>eBiene mySQL-Backup</td>
		      <td width="100%" valign=top class=small>Version <?php echo MYSQL_BACKUP_VERSION ?></td>
		    </tr>
	    </table>
      
      <table width=505 cellspacing=0 cellpadding=5 border=1 class=content>
		    <?php if (isset($mysql_tables) && $mysql_tables) {
		      // mySQL-Tabellen auflisten ?>	  
	        <form name="mysql_backup" method=post onSubmit="return submitForm()">
		      <input type=hidden name="mysql_action" value=backup>
		      <tr>
			      <td colspan=3 align=right><select name="mysql_extras" onChange="document.mysql_backup.mysql_extras_copy.value=this.value" class=change>
			        <option value="save_as_sql">Tabellen auf dem WebServer als SQL ablegen
			        <option value="save_as_gzip">Tabellen auf dem WebServer als GZIP ablegen
			        <option value="save_as_sql_with_date">Tabellen auf dem WebServer als SQL mit Datum im Namen ablegen
			        <option value="save_as_gzip_with_date">Tabellen auf dem WebServer als GZIP mit Datum im Namen ablegen
			        <option value="download_as_sql">Tabellen als SQL downloaden
			        <option value="download_as_sql_with_date">Tabellen als SQL mit Datum im Namen downloaden
			      </select>&nbsp;<input type=submit value="Backup!" class=button></td>
		      </tr>
		      <tr>
		        <td align=center class=small><a href="javascript:checkElements()">Alle</a></td>
		        <td width="100%" class=small>Name der Tabelle (<?php echo count($mysql_tables) ?> insgesamt)</td>
			      <td align=center class=small>Eintr&auml;ge</td>
		      </tr>
		      
          <?php foreach ($mysql_tables as $key => $value) { ?>
		        <tr>
		          <td align=center><input type=checkbox name="mysql_tables[]" value="<?php echo $value['table_name'] ?>" checked></td>
		          <td width="100%"><?php echo $value['table_name'] ?></td>
			        <td align=center class=small><?php echo $value['data_counter'] ?></td>
		        </tr>
		      <?php } ?>
		      
          <tr>
			      <td colspan=3 align=right><select name="mysql_extras_copy" onChange="document.mysql_backup.mysql_extras.value=this.value" class=change>
			        <option value="save_as_sql">Tabellen auf dem WebServer als SQL ablegen
			        <option value="save_as_gzip">Tabellen auf dem WebServer als GZIP ablegen
			        <option value="save_as_sql_with_date">Tabellen auf dem WebServer als SQL mit Datum im Namen ablegen
			        <option value="save_as_gzip_with_date">Tabellen auf dem WebServer als GZIP mit Datum im Namen ablegen
			        <option value="download_as_sql">Tabellen als SQL downloaden
			        <option value="download_as_sql_with_date">Tabellen als SQL mit Datum im Namen downloaden
			      </select>&nbsp;<input type=submit value="Backup!" class=button></td>
		      </tr>
		      </form>
		    <?php } else if ($GLOBALS['internal_messages']) { ?>
		      <tr>
		        <td>
			        <table cellspacing=0 cellpadding=0 border=0>
			          <?php foreach ($GLOBALS['internal_messages'] as $key => $value) {
		              // Meldungen ausgeben ?>
		              <tr>
			              <td width="100%" nowrap class=<?php echo $value['style'] ?>>&middot; <?php echo $value['string'] ?></td>
		              </tr>
		            <?php } ?>
			        </table>
			      </td>
			      <td align=center nowrap>>> <a href="<?php echo $_SERVER['PHP_SELF'] ?>">Tabellen auflisten</a></td>
		      </tr>
		    <?php } ?>
	    </table>
	    
	    <table width=505 height=30 cellspacing=0 cellpadding=2 border=0>
	      <tr>
		      <td nowrap class=small><a href="http://lab.eBiene.de" target="_blank">eBiene flying laboratory</a></td>
		      <td class=small>&nbsp;|&nbsp;</td>
		      <td nowrap class=small>Elapsed Time: <?php echo $GLOBALS['global_class']->get_global_endtime() ?></td>
		      <td class=small>&nbsp;|&nbsp;</td>
		      <td nowrap class=small>Queries: <?php echo (isset($GLOBALS['mysql_class']->quries_counter) ? $GLOBALS['mysql_class']->quries_counter : 0) ?></td>
		      <td class=small>&nbsp;|&nbsp;</td>
		      <td nowrap class=small><a href="?get_version_control=true">Auf neue Version prfen</a></td>
		    </tr>
	    </table>
    
    </td>
  </tr>
</table>
</body>

</html>