<?php //  -----------------------------------------------------------------  //
//  Projekt: eBiene mySQL-Backup 0.7                                         //
//  Download: http://lab.eBiene.de                                           //
//  Autor: Sergej Mueller                                                    //
//                                                                           //
//  Dateiname: require/backup.class.php                                      //
//  Bearbeitungsdatum: 16. Februar 2004                                      //
//  -----------------------------------------------------------------------  //

class backup_mysql_class {
  // Groesse der Datei
  var $file_length;
  
  // Pfad zur Datei
  var $file_path;
  
  
  /**
  * backup_mysql_tables
  *
  * Erstellt ein Backup der SQL-Tabellen
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @return   boolean  true/false  TRUE bei Erfolg, FALSE bei Fehlern
  */
  
  function backup_mysql_tables() {
    
	  // Keine Tabelle ausgewaehlt?
	  if (!isset($_POST['mysql_tables'])) {
	    $GLOBALS['global_class']->cache_error_messages('Mindestens eine Tabelle muss ausgew&auml;hlt sein!');
	    return false;
	  }
	  
    // Variablen definieren
	  $table_data = "# eBiene mySQL-Backup\r\n" .
				          "# Version: " .MYSQL_BACKUP_VERSION. "\r\n" .
				          "# Download: http://lab.eBiene.de\r\n\r\n" .
				          "# Host: " .MYSQL_HOST. "\r\n" .
				          "# Datenbank: " .MYSQL_DATABASE. "\r\n" .
				          "# Erstellt: " .strftime("%d. %B %Y um %R"). "\r\n";
    
	  // DROP-Befehl definieren
	  if (strcmp(mysql_get_client_info(), '3.22') < 0) {
	    $drop_table = 'DROP TABLE';
	  } else {
	    $drop_table = 'DROP TABLE IF EXISTS';
	  }
	  
	  // Verbindung herstellen
	  $GLOBALS['mysql_class']->check_mysql_connection();
	  
	  // Keine Anfuehrungszeichen in mySQL-Namen
	  $GLOBALS['mysql_class']->get_unbuffered_query('SET SQL_QUOTE_SHOW_CREATE = 0');
	  
	  // Werte & Struktur der Tabellen ermitteln
    foreach ($_POST['mysql_tables'] as $key => $mysql_table) {
	    if (!$select_results = $GLOBALS['mysql_class']->get_fetch_array('SELECT * FROM ' .$mysql_table, MYSQL_ASSOC)) {
	      continue;
	    }
	    
	    ##### DROP TABLE #####
	    // Aktuelle Ueberschrift
	    $table_data .= "\r\n\r\n# Entfernen der Tabelle " .$mysql_table. "\r\n#\r\n";
	    
	    // Aktuelle Werte
	    $table_data .= $drop_table. ' ' .$mysql_table. ";\r\n";
	    
	    ##### SHOW CREATE TABLE #####
	    // Aktuelle Ueberschrift
	    $table_data .= "\r\n# Erzeugen der Tabelle " .$mysql_table. "\r\n#\r\n";
      
	    // Daten auslesen
	    if (!$show_results = $GLOBALS['mysql_class']->get_fetch_row('SHOW CREATE TABLE ' .$mysql_table)) {
	      $GLOBALS['global_class']->cache_error_messages('Befehl "SHOW CREATE TABLE" kontte nicht ausgef&uuml;hrt werden!');
		    return false;
	    }
	    $show_results[1] = str_replace("\n", "\r\n", $show_results[1]);
      
	    // Aktuelle Werte
	    $table_data .= $show_results[1]. ";\r\n";
	    
	    ##### INSERT INTO TABLE #####
	    // Aktuelle Ueberschrift
	    $table_data .= "\r\n# Daten fr Tabelle " .$mysql_table. "\r\n#\r\n";
      
	    // Daten aufbereiten
	    foreach ($select_results as $key => $select_result) {
	      foreach (array_keys($select_result) as $table_field) {
		      // Struktur der Tabelle
		      if (isset($table_structure)) {
			      $table_structure .= ", " .$table_field;
		      } else {
			      $table_structure = $table_field;
		      }
		      
		      // Werte der Tabelle
		      if (preg_match("/^[0-9]+,*$/", $select_result[$table_field])) {
		        $temp_table_value = $select_result[$table_field];
		      } else {
			      $temp_table_value = "'" .mysql_escape_string($select_result[$table_field]). "'";
		      }
		      if (isset($table_value)) {
			      $table_value .= ", " .$temp_table_value;
		      } else {
			      $table_value = $temp_table_value;
		      }
		    }
		    
		    // Aktuelle Werte
		    $table_data .= "INSERT INTO " .$mysql_table. " (" .$table_structure. ") VALUES (" .$table_value. ");\r\n";
		    
		    // Temporaere Werte annulieren
	      unset($table_structure, $table_value);
	    }
	  }
	  
	  // Verbindung trennen
	  $GLOBALS['mysql_class']->close_mysql_connection();
	  
	  // Groesse der Backup-Datei
	  $this->file_length = strlen($table_data);
	  
	  // Pfad zur Datei
	  $this->file_path = str_replace($_SERVER['DOCUMENT_ROOT'], '', BACKUP_FILES_ROOT);
	  
	  // Backup-Datei ausgeben
	  if (preg_match("/^save_as/", $_POST['mysql_extras'])) {
	    if (!defined('BACKUP_FILES_ROOT')) {
	      $GLOBALS['global_class']->cache_error_messages('Pfad zum Backup-Ordner ist nicht definiert!');
		    return false;
	    }
	    if (!file_exists(BACKUP_FILES_ROOT)) {
	      $GLOBALS['global_class']->cache_error_messages('Backup-Ordner [BACKUP_FILES_ROOT] existiert nicht!');
		    return false;
	    }
	    if (disk_free_space(BACKUP_FILES_ROOT) < $this->file_length) {
	      $GLOBALS['global_class']->cache_error_messages('Es steht nicht gen&uuml;gend Speicherplatz zur Verf&uuml;gung!');
		    return false;
	    }
	    
	    // Auf dem WebServer als SQL ablegen
	    if ($_POST['mysql_extras'] == 'save_as_sql') {
        $this->save_sql_file($table_data, MYSQL_DATABASE. '.sql');
	    }
	    // Auf dem WebServer als GZIP ablegen
	    if ($_POST['mysql_extras'] == 'save_as_gzip') {
	      $this->save_gzip_file($table_data, MYSQL_DATABASE. '.sql.gz');
	    }
	    // Auf dem WebServer als SQL mit Datum im Namen ablegen
	    if ($_POST['mysql_extras'] == 'save_as_sql_with_date') {
	      $this->save_sql_file($table_data, MYSQL_DATABASE. '_' .date('Ymd'). '.sql');
      }
	    // Auf dem WebServer als GZIP mit Datum im Namen ablegen
	    if ($_POST['mysql_extras'] == 'save_as_gzip_with_date') {
	      $this->save_gzip_file($table_data, MYSQL_DATABASE. '_' .date('Ymd'). '.sql.gz');
	    }
	  } else {
	    // SQL-Datei downloaden
	    if ($_POST['mysql_extras'] == 'download_as_sql') {
	      $this->download_sql_file($table_data, MYSQL_DATABASE. '.sql');
	    }
	    // SQL-Datei mit Datum im Namen downloaden
	    if ($_POST['mysql_extras'] == 'download_as_sql_with_date') {
	      $this->download_sql_file($table_data, MYSQL_DATABASE. '_' .date('Ymd'). '.sql');
	    }
	  }
  }
  
  
  /**
  * save_sql_file
  *
  * SQL-Datei auf dem Server erstellen
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @param    string   $file_content  Content der Datei
  * @param    string   $file_name     Name der Datei
  * @return   boolean  true/false     TRUE bei Erfolg, FALSE bei Fehlern
  */
  
  function save_sql_file($file_content, $file_name) {
    $file_path = BACKUP_FILES_ROOT . $file_name;
	  
    if (!$handle = @fopen($file_path, 'w')) {
	    $GLOBALS['global_class']->cache_error_messages('SQL-Datei "' .$file_name. '" konnte nicht ge&ouml;ffnet werden!');
      return false;
	  }
    if (fwrite($handle, $file_content, $this->file_length)) {
	    fclose($handle);
	    $GLOBALS['global_class']->cache_error_messages('SQL-Datei "' .$file_name. '" wurde erfolgreich unter "' .$this->file_path. '" abgelegt!', 'done');
      return true;
	  } else {
      $GLOBALS['global_class']->cache_error_messages('SQL-Datei "' .$file_name. '" konnte nicht beschrieben werden!');
      return false;
    }
  }
  
  
  /**
  * save_gzip_file
  *
  * GZIP-Datei auf dem Server erstellen
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @param    string   $file_content  Content der Datei
  * @param    string   $file_name     Name der Datei
  * @return   boolean  true/false     TRUE bei Erfolg, FALSE bei Fehlern
  */
  
  function save_gzip_file($file_content, $file_name) {
    $file_path = BACKUP_FILES_ROOT . $file_name;
	  
	  if (!PHP_ZLIB_EXTENSION) {
	    $GLOBALS['global_class']->cache_error_messages('ZLIB-Bibliothek ist auf dem WebServer nicht installiert!');
      return false;
	  }
	  
    if (!$handle = @gzopen($file_path, 'w9')) {
	    $GLOBALS['global_class']->cache_error_messages('GZIP-Datei "' .$file_name. '" konnte nicht ge&ouml;ffnet werden!');
      return false;
	  }
	  if (gzwrite($handle, $file_content, $this->file_length)) {
	    gzclose($handle);
	    $GLOBALS['global_class']->cache_error_messages('GZIP-Datei "' .$file_name. '" wurde erfolgreich unter "' .$this->file_path. '" abgelegt!', 'done');
      return true;
	  } else {
      $GLOBALS['global_class']->cache_error_messages('GZIP-Datei "' .$file_name. '" konnte nicht beschrieben werden!');
      return false;
    }
  }
  
  
  /**
  * download_sql_file
  *
  * SQL-Datei downloaden
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @param    string  $file_content  Content der Datei
  * @param    string  $file_name     Name der Datei
  */
  
  function download_sql_file($file_content, $file_name) {
    header("Content-Type: application/octet-stream");
    header("Content-Disposition: attachment; filename=" .$file_name);
    header("Content-Length: " .$this->file_length);
	  
	  echo $file_content;
	  exit;
  }
} ?>