<?php //  -----------------------------------------------------------------  //
//  Projekt: eBiene mySQL-Backup 0.7                                         //
//  Download: http://lab.eBiene.de                                           //
//  Autor: Sergej Mueller                                                    //
//                                                                           //
//  Dateiname: require/mysql.class.php                                       //
//  Bearbeitungsdatum: 16. Februar 2004                                      //
//  -----------------------------------------------------------------------  //

class mysql_database_class {
  // mySQL-Verbindung
  var $mysql_connection;
  
  // mySQL-Query
  var $get_mysql_query;
  
  // mySQL-Datensaetze
  var $query_num_rows;
  
  // mySQL-insertID
  var $query_insert_id;
  
  // Queries-Counter
  var $quries_counter = 0;
  
  
  /**
  * connect_mysql_database
  *
  * mySQL-Verbindung herstellen
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @return   boolean  true/false  TRUE bei Erfolg, FALSE bei Fehlern
  */
  
  function connect_mysql_database() {
    // Globale Variablen auf Existenz pruefen
    if (!defined('MYSQL_HOST')) {
	    $GLOBALS['global_class']->cache_error_messages('mySQL-Host [MYSQL_HOST] ist nicht definiert!');
	    return false;
	  }
	  if (!defined('MYSQL_USER') || MYSQL_USER == 'undefined') {
	    $GLOBALS['global_class']->cache_error_messages('mySQL-User [MYSQL_USER] ist nicht definiert!');
	    return false;
	  }
	  if (!defined('MYSQL_PASSWORD') || MYSQL_PASSWORD == 'undefined') {
	    $GLOBALS['global_class']->cache_error_messages('mySQL-Passwort [MYSQL_PASSWORD] ist nicht definiert!');
	    return false;
	  }
	  
	  // Verbindung herstellen
	  if (strcmp(PHP_VERSION, '4.3.0') < 0) {
	    $this->mysql_connection = @mysql_connect(MYSQL_HOST, MYSQL_USER, MYSQL_PASSWORD);
	  } else {
	    $this->mysql_connection = @mysql_connect(MYSQL_HOST, MYSQL_USER, MYSQL_PASSWORD, '', MYSQL_CLIENT_COMPRESS);
	  }
	  
    if (mysql_error()) {
	    $GLOBALS['global_class']->cache_error_messages('mySQL-Datenbank [MYSQL_DATABASE] konnte nicht erreicht werden!');
      return false;
	  }
	  
	  // Datenbank selektieren
	  @mysql_select_db(MYSQL_DATABASE, $this->mysql_connection);
	  if (mysql_error()) {
	    $GLOBALS['global_class']->cache_error_messages('mySQL-Datenbank [MYSQL_DATABASE] konnte nicht selektiert werden!');
	    return false;
	  } else {
	    return true;
    }
  }
  
  
  /**
  * check_mysql_connection
  *
  * mySQL-Verbindung pruefen
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  */
  
  function check_mysql_connection() {
    if (!isset($this->mysql_connection)) {
	    $this->connect_mysql_database();
	  }
  }
  
  
  /**
  * close_mysql_connection
  *
  * mySQL-Verbindung trennen
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @return   boolean  true/false  TRUE bei Erfolg, FALSE bei Fehlern
  */
  
  function close_mysql_connection() {
    if ($this->mysql_connection) {
	    if (!mysql_close($this->mysql_connection)) {
	      $GLOBALS['global_class']->cache_error_messages('mySQL-Verbindung konnte nicht getrennt werden!');
	      return false;
	    }
	  }
  }
  
  
  /**
  * get_mysql_query
  *
  * mySQL-Query ausfuehren
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @param    string  $mysql_query   mySQL-Query
  * @return   array   $query_result  Resultat der mySQL-Query
  */
  
  function get_mysql_query($mysql_query) {
    // Query vorhanden?
	  if (!$mysql_query) {
	    $GLOBALS['global_class']->cache_error_messages('mySQL-Query darf nicht leer sein!');
	    return false;
	  }
	  
	  // Query senden
    $query_result = mysql_query($mysql_query, $this->mysql_connection);
	  
	  // Zusatzinfos ermitteln
	  if (preg_match("/^SELECT/i", $mysql_query)) {
	    $this->query_num_rows = mysql_num_rows($query_result);
	  } else if (preg_match("/^(INSERT|UPDATE|DELETE)/i", $mysql_query)) {
	    $this->query_num_rows = mysql_num_rows($this->mysql_connection);
	    if (preg_match("/^INSERT/i", $mysql_query)) {
	      $this->query_insert_id = mysql_insert_id($this->mysql_connection);
	    }
	  }
	  
	  // Query-Abfrage fehlerhaft?
	  if (mysql_error()) {
	    $GLOBALS['global_class']->cache_error_messages('mySQL-Query konnte nicht erfolgreich ausgefrt werden! ' .mysql_error(). '.');
	    return false;
	  }
	  
	  $this->quries_counter ++;
	  return $query_result;
  }
  
  
  /**
  * get_unbuffered_query
  *
  * Unbuffered-Query ausfuehren
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @param    string   $mysql_query  mySQL-Query
  * @return   boolean  true/false    TRUE bei Erfolg, FALSE bei Fehlern
  */
  
  function get_unbuffered_query($mysql_query) {
	  // Query vorhanden?
	  if (!$mysql_query) {
	    $GLOBALS['global_class']->cache_error_messages('mySQL-Query darf nicht leer sein!');
	    return false;
	  }
	  
	  // Query senden
    mysql_unbuffered_query($mysql_query, $this->mysql_connection);
	  
	  // Query-Abfrage fehlerhaft?
	  if (mysql_error()) {
	    $GLOBALS['global_class']->cache_error_messages('mySQL-Query konnte nicht erfolgreich ausgefrt werden! ' .mysql_error(). '.');
	    return false;
	  }
	  
	  $this->quries_counter ++;
  }
  
  
  /**
  * get_fetch_array
  *
  * mySQL-Datensatz als assoziatives Array
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @param    string  $mysql_query   mySQL-Query
  * @param    string  $result_type   mySQL-Type [optional]
  * @return   array   $return_array  Indiziertes Array
  */
  
  function get_fetch_array($mysql_query, $result_type = MYSQL_NUM) {
    // Array initialisieren
	  $return_array = array();
	  
    // Query ausfuehren
	  $query_result = $this->get_mysql_query($this->trim_mysql_query($mysql_query));
	  
	  // Werte zuweisen
	  while ($result_row = mysql_fetch_array($query_result, $result_type)) {
	    $return_array[] = $result_row;
	  }
	  
	  // Speicher freigeben
	  mysql_free_result($query_result);
	  return $return_array;
  }
  
  
  /**
  * get_fetch_row
  *
  * mySQL-Datensatz als indiziertes Array
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @param    string  $mysql_query   mySQL-Query
  * @return   array   $return_array  Indiziertes Array
  */
  
  function get_fetch_row($mysql_query) {
    // Array initialisieren
	  $return_array = array();
	  
	  // Query ausfuehren
	  $query_result = $this->get_mysql_query($this->trim_mysql_query($mysql_query));
	  
	  // Werte zuweisen
	  while ($result_row = mysql_fetch_row($query_result)) {
	    while (list($key, $value) = each($result_row)) {
	      $return_array[] = $value;
	    }
	  }
	  
	  // Speicher freigeben
	  mysql_free_result($query_result);
	  return $return_array;
  }
  
  
  /**
  * trim_mysql_query
  *
  * Leerzeichen aus dem String entfernen
  *
  * @package  eBiene mySQL-Backup 0.7
  * @author   Sergej Mueller
  * @since    16.02.2004
  * @access		private
  * @param    string  $mysql_query  mySQL-Query
  * @return   string                mySQL-Query ohne Leerzeichen
  */
  
  function trim_mysql_query($mysql_query) {
    return trim($mysql_query);
  }
}
?>